package org.zheng.demo;

import org.junit.jupiter.api.extension.AfterTestExecutionCallback;
import org.junit.jupiter.api.extension.BeforeTestExecutionCallback;
import org.junit.jupiter.api.extension.ExtensionContext;

public class NanosecondsTimeExtension implements BeforeTestExecutionCallback, AfterTestExecutionCallback {

	private static final String START_TIME = "startTime";

	@Override
	public void afterTestExecution(ExtensionContext context) throws Exception {
		ExtensionContext.Store store = context.getStore(ExtensionContext.Namespace.GLOBAL);
		long startTime = store.remove(START_TIME, long.class);
		long endTime = System.nanoTime();
		long execTimeInNS = (endTime - startTime);
		System.out.println(context.getDisplayName() + " took " + execTimeInNS + " Nanoseconds");
	}

	@Override
	public void beforeTestExecution(ExtensionContext context) throws Exception {
		ExtensionContext.Store store = context.getStore(ExtensionContext.Namespace.GLOBAL);
		store.put(START_TIME, System.nanoTime());
	}

}
