package org.zheng.demo;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertThrows;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.util.stream.IntStream;

import org.apache.commons.lang3.ArrayUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;

@ExtendWith(NanosecondsTimeExtension.class)
class TestCheckIntArray {
	int[] emptyArray = {};
	int[] intArray = IntStream.generate(() -> 1000).limit(1000).toArray();
	int[] nullArray = null;

	private CheckArrayUtils testClass = new CheckArrayUtils();

	@Test
	void test_ApacheArraysUtils_isEmpty() {
		assertTrue(ArrayUtils.isEmpty(nullArray));
		assertTrue(ArrayUtils.isEmpty(emptyArray));
		assertFalse(ArrayUtils.isEmpty(intArray));
	}

	@Test
	void test_ApacheObjectUtils_isEmpty() {
		assertTrue(ObjectUtils.isEmpty(nullArray));
		assertTrue(ObjectUtils.isEmpty(emptyArray));
		assertFalse(ObjectUtils.isEmpty(intArray));
	}

	@Test
	void test_emptyCheck() {
		assertTrue(testClass.isEmpty(nullArray));
		assertTrue(testClass.isEmpty(emptyArray));
		assertFalse(testClass.isEmpty(intArray));
	}

	@Test
	void test_nullCheck() {
		assertTrue(testClass.isNull(nullArray));
		assertFalse(testClass.isNull(emptyArray));
		assertFalse(testClass.isNull(intArray));
	}

	@Test
	void test_nullPointerException() {
		assertThrows(NullPointerException.class, () -> {
			System.out.println("  emptyArray size is " + emptyArray.length);
			System.out.println("  never print out due to NullPointerException" + nullArray.length);
		});

	}

}
